package com.ruoyi.system.service.impl;


import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.common.core.domain.entity.SysUser;
import com.ruoyi.common.utils.SecurityUtils;

import com.ruoyi.system.mapper.PowerDisplayMapper;
import com.ruoyi.system.model.newrule.NewRuleRequestModel;
import com.ruoyi.system.model.power.FilterModel;
import com.ruoyi.system.model.power.PowerConvertSourceModel;
import com.ruoyi.system.model.power.PowerSourceModel;
import com.ruoyi.system.model.power.SourceIndfoModel;
import com.ruoyi.system.model.power.dao.PowerClassificationQueryDao;
import com.ruoyi.system.model.power.dao.PowerControlDao;
import com.ruoyi.system.model.power.dto.PowerDisplayDto;
import com.ruoyi.system.model.salary.ConfigModel;
import com.ruoyi.system.service.PowerDisplayService;
import com.ruoyi.system.service.impl.saveOnTheLargeScreenPower.*;
import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Service;
import org.springframework.util.CollectionUtils;
import org.springframework.util.ReflectionUtils;
import redis.clients.jedis.Jedis;

import java.lang.reflect.Field;
import java.lang.reflect.Method;
import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.*;
import java.util.concurrent.atomic.AtomicBoolean;
import java.util.stream.Collectors;
import java.util.stream.Stream;

/**
 * 2024/7/30
 */
@Service
public class PowerDisplayServiceImpl implements PowerDisplayService {
    private final PowerDisplayMapper powerDisplayMapper;

    PowerDisplayServiceImpl(PowerDisplayMapper powerDisplayMapper) {
        this.powerDisplayMapper = powerDisplayMapper;
    }


    @Override
    public void peek(List<NewRuleRequestModel> electricityIntoTheParameterDtoDtoList) {
        Jedis redis = new Jedis("192.168.111.226", 6379);
        SysUser user = SecurityUtils.getLoginUser().getUser();
        if (redis.exists("电力导入" + user) && redis.get("电力导入" + user).equals("电力导入大屏")) {
            redis.close();
            return;
        }
        redis.set("电力导入" + user, "电力导入大屏");
        redis.expire("电力导入" + user, 5);
        redis.close();
        electricityIntoTheParameterDtoDtoList.forEach(v -> v.setRow(v.getRow().split("-")[1]));
        electricityIntoTheParameterDtoDtoList.forEach(v -> v.setRow(v.getRow().replace(" ", "")));
        String mindId = electricityIntoTheParameterDtoDtoList.get(0).getMineid().replaceAll(" ", "");
        List<PowerControlDao> controlList = powerDisplayMapper.selControl(mindId);
        List<PowerDisplayDto> powerDisplayDtoList = new ArrayList<>();
        Class<PowerDisplayDto> powerDisplayDtoClass = PowerDisplayDto.class;
        AtomicBoolean b = new AtomicBoolean(false);
        PowerDisplayDto xs011701 = null;
        electricityIntoTheParameterDtoDtoList.forEach(v -> {
            if (controlList.parallelStream().noneMatch(a -> a.getColumn().equals(v.getColoumn()))) return;
            PowerDisplayDto displayDto;
            if ("011704".equals(mindId) && v.getRow().equals("电价（含税）")) return;
            if ("010105".equals(mindId) && (v.getRow().contains("（尖）") || v.getRow().contains("（峰）") || v.getRow().contains("（平）") || v.getRow().contains("（谷）") || v.getColoumn().equals("单价")))
                return;
            if ("011701".equals(mindId) && (v.getColoumn().equals("照明电价") || v.getColoumn().equals("动力电价") || v.getRow().contains("多经公司")))
                return;
            if (!powerDisplayDtoList.isEmpty()) {
                powerDisplayDtoList.removeAll(Collections.singleton(null));
                b.set(powerDisplayDtoList.stream().anyMatch(a -> a.getClassificationName().equals(v.getRow())));
            }
            if (b.get()) {
                displayDto = powerDisplayDtoList.stream().filter(a -> a.getClassificationName().equals(v.getRow())).findFirst().get();
            } else {
                displayDto = new PowerDisplayDto();
                displayDto.setClassificationName(v.getRow());
                powerDisplayDtoList.add(displayDto);
            }
            if (mindId.equals("011701") && v.getRow().equals("线损") && v.getColoumn().equals("本月")) {
                xs011701.setPowerTotal(v.getValue());
                return;
            }
            Optional<PowerControlDao> first = controlList.parallelStream().filter(a -> a.getColumn().equals(v.getColoumn())).findFirst();
            if (first.isPresent() && first.get().getColumn() != null && first.get().getField() != null) {
                PowerControlDao powerControlDao = first.get();
                try {
                    Method method = powerDisplayDtoClass.getMethod("set" + powerControlDao.getField(), String.class);
                    method.invoke(displayDto, v.getValue());
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
            b.set(false);
        });
        List<PowerClassificationQueryDao> dao = powerDisplayMapper.selectClassificationToMid(mindId);
        SaveOnTheLargeScreenImpl saveOnTheLargeScreen = null;
        List<String> linXi = Collections.singletonList("011704");
        List<String> lvJiaTuo = Collections.singletonList("011702");
        List<String> danHou = Collections.singletonList("011204");
        List<String> dongHuanTuo = Collections.singletonList("010102");
        List<String> qianJiaYing = Collections.singletonList("010105");
        List<String> fanGeZhuang = Collections.singletonList("011701");
        List<String> tangShanKuang = Collections.singletonList("010101");
        List<String> field = powerDisplayMapper.selField(mindId);
        List<PowerDisplayDto> collect1 = powerDisplayDtoList.parallelStream().filter(v -> !field.contains(v.getClassificationName())).collect(Collectors.toList());
        if (linXi.contains(mindId)) {
            List<NewRuleRequestModel> collect = electricityIntoTheParameterDtoDtoList.parallelStream().filter(v -> v.getRow().equals("电价（含税）")).collect(Collectors.toList());
            collect.forEach(v -> v.setColoumn(v.getColoumn() + "-费"));
            if (!collect.isEmpty()) {
                collect.parallelStream().forEach(v -> {
                    Optional<PowerControlDao> first = controlList.parallelStream().filter(a -> a.getColumn().equals(v.getColoumn())).findFirst();
                    try {
                        if (first.isPresent()) {
                            PowerControlDao powerControlDao = first.get();
                            Method method = powerDisplayDtoClass.getMethod("set" + powerControlDao.getField(), String.class);
                            for (PowerDisplayDto displayDto : collect1) {
                                method.invoke(displayDto, v.getValue());
                            }
                        }
                    } catch (Exception e) {
                        e.printStackTrace();
                    }
                });
            }
            saveOnTheLargeScreen = new SaveOnTheLargeScreenImpl(new LinXi());
        } else if (lvJiaTuo.contains(mindId)) {
            saveOnTheLargeScreen = new SaveOnTheLargeScreenImpl(new LvJiaTuo());
        } else if (danHou.contains(mindId)) {
            saveOnTheLargeScreen = new SaveOnTheLargeScreenImpl(new DanHou());
        } else if (dongHuanTuo.contains(mindId)) {
            saveOnTheLargeScreen = new SaveOnTheLargeScreenImpl(new DongHuanTuo());
        } else if (qianJiaYing.contains(mindId)) {
            List<NewRuleRequestModel> collect = electricityIntoTheParameterDtoDtoList.parallelStream().filter(v -> v.getRow().contains("（尖）") || v.getRow().contains("（峰）") || v.getRow().contains("（平）") || v.getRow().contains("（谷）")).collect(Collectors.toList());
            if (!collect.isEmpty()) {
                PowerDisplayDto displayDto;
                for (NewRuleRequestModel dto : collect) {
                    String[] split = dto.getRow().split("-");
                    Optional<PowerDisplayDto> first = collect1.parallelStream().filter(v -> v.getClassificationName().equals(split[0])).findFirst();
                    if (first.isPresent()) displayDto = first.get();
                    else {
                        displayDto = new PowerDisplayDto();
                        displayDto.setClassificationName(split[0]);
                    }
                    try {
                        Method method = powerDisplayDtoClass.getMethod("set" + dto.getColoumn(), String.class);
                        method.invoke(displayDto, dto.getValue());
                    } catch (Exception e) {
                        e.printStackTrace();
                    }
                }
            }
            saveOnTheLargeScreen = new SaveOnTheLargeScreenImpl(new QianJiaYing());
        } else if (fanGeZhuang.contains(mindId)) {
            List<NewRuleRequestModel> collect = electricityIntoTheParameterDtoDtoList.parallelStream().filter(v -> v.getRow().contains("多经公司")).collect(Collectors.toList());
            if (!collect.isEmpty()) {
                PowerDisplayDto dto = new PowerDisplayDto();
                String[] split = collect.get(0).getRow().split("-");
                dto.setClassificationName(split[0]);
                for (NewRuleRequestModel model : collect) {
                    String[] strings = model.getRow().split("-");
                    switch (strings[1]) {
                        case "峰":
                            dto.setPowerPeak(model.getValue());
                            break;
                        case "平":
                            dto.setPowerFlat(model.getValue());
                            break;
                        case "谷":
                            dto.setPowerValley(model.getValue());
                            break;
                        case "尖":
                            dto.setPowerTip(model.getValue());
                            break;
                    }
                }
            }
            saveOnTheLargeScreen = new SaveOnTheLargeScreenImpl(new FanGeZhuang());
        } else if (tangShanKuang.contains(mindId)) {
            saveOnTheLargeScreen = new SaveOnTheLargeScreenImpl(new TangShanKuang());
        }
        if (saveOnTheLargeScreen != null) {
            // 添加费用来源
            List<PowerDisplayDto> list = saveOnTheLargeScreen.save(mindId, collect1, dao);
            // 单另处理电费
            if (mindId.equals("010105")) method(list, electricityIntoTheParameterDtoDtoList);
            if (mindId.equals("011701")) methodFgz(list, electricityIntoTheParameterDtoDtoList);
            list.forEach(v -> {
                if (v.getLevelOneClassification() == null || v.getLevelOneClassification().isEmpty())
                    v.setLevelOneClassification("其他");
                v.setMindId(mindId);
                v.setDateColumn(electricityIntoTheParameterDtoDtoList.get(0).getWageMonth());
            });
            list = list.stream().filter(v -> !v.getClassificationName().contains("合计")).collect(Collectors.toList());
            powerDisplayMapper.insert(list);
//            List<PowerDisplayDto> selPower = powerDisplayMapper.selOfMid(mindId, electricityIntoTheParameterDtoDtoList.get(0).getWageMonth());
//            selPower.removeAll(Collections.singleton(null));
//            // 已有不需新增
//            List<PowerDisplayDto> collect = list.stream()
//                    .filter(v -> selPower.stream().anyMatch(a -> v.getClassificationName().equals(a.getClassificationName()))
//                            && selPower.stream().anyMatch(a -> v.getLevelOneClassification().equals(a.getLevelOneClassification())))
//                    .collect(Collectors.toList());
//            // 需新增
//            List<PowerDisplayDto> dtoList = list.stream()
//                    .filter(v -> !selPower.stream().anyMatch(a -> v.getClassificationName().equals(a.getClassificationName()))
//                            && !selPower.stream().anyMatch(a -> v.getLevelOneClassification().equals(a.getLevelOneClassification())))
//                    .collect(Collectors.toList());
//            if (dtoList.size() != 0) powerDisplayMapper.insert(dtoList);
//            if (collect.size() != 0) powerDisplayMapper.update(collect);
        }
    }


    /**
     * 011701电价的处理方法
     *
     * @param list
     * @param electricityIntoTheParameterDtoDtoList
     */
    private void methodFgz(List<PowerDisplayDto> list, List<NewRuleRequestModel> electricityIntoTheParameterDtoDtoList) {
        String electricityPricesForLighting = electricityIntoTheParameterDtoDtoList.parallelStream().filter(v -> v.getColoumn().equals("照明电价")).findFirst().get().getValue();
        String powerTariff = electricityIntoTheParameterDtoDtoList.parallelStream().filter(v -> v.getColoumn().equals("动力电价")).findFirst().get().getValue();
        list.parallelStream().forEach(v -> {
            if ((v.getElectricityPriceFlat() != null && !v.getElectricityPriceFlat().isEmpty()) || (v.getElectricityPricePeak() != null && !v.getElectricityPricePeak().isEmpty()) || (v.getElectricityPriceTip() != null && !v.getElectricityPriceTip().isEmpty()) || (v.getElectricityPriceValley() != null && !v.getElectricityPriceValley().isEmpty()))
                return;
            if (v.getLevelThreeClassification().equals("动力用电")) {
                v.setElectricityPriceValley(powerTariff);
                v.setElectricityPriceFlat(powerTariff);
                v.setElectricityPricePeak(powerTariff);
                v.setElectricityPriceTip(powerTariff);
            }
            if (v.getLevelThreeClassification().equals("照明用电")) {
                v.setElectricityPriceValley(electricityPricesForLighting);
                v.setElectricityPriceFlat(electricityPricesForLighting);
                v.setElectricityPricePeak(electricityPricesForLighting);
                v.setElectricityPriceTip(electricityPricesForLighting);
            }
        });
    }

    /**
     * 010105电价的处理方法
     *
     * @param list
     * @param electricityIntoTheParameterDtoDtoList
     */
    private void method(List<PowerDisplayDto> list, List<NewRuleRequestModel> electricityIntoTheParameterDtoDtoList) {
        for (PowerDisplayDto dto : list) {
            if ((dto.getElectricityPriceFlat() == null || dto.getElectricityPriceFlat().isEmpty()) && (dto.getElectricityPricePeak() == null || dto.getElectricityPricePeak().isEmpty()) && (dto.getElectricityPriceTip() == null || dto.getElectricityPriceTip().isEmpty()) && (dto.getElectricityPriceValley() == null || dto.getElectricityPriceValley().isEmpty())) {
                Optional<NewRuleRequestModel> first = electricityIntoTheParameterDtoDtoList.parallelStream().filter(v -> (v.getRow().equals(dto.getLevelOneClassification()) || v.getRow().equals(dto.getLevelTwoClassification())) && v.getColoumn().equals("单价")).findFirst();
                if (first.isPresent()) {
                    NewRuleRequestModel model = first.get();
                    dto.setElectricityPriceValley(model.getValue());
                    dto.setElectricityPriceFlat(model.getValue());
                    dto.setElectricityPricePeak(model.getValue());
                    dto.setElectricityPriceTip(model.getValue());
                }
            }
        }
    }

    @Override
    public AjaxResult save(List<NewRuleRequestModel> newRuleRequestModelList) {
        if (!CollectionUtils.isEmpty(newRuleRequestModelList)) {
            String mineid = newRuleRequestModelList.get(0).getMineid();
            //吕家坨
            if (StringUtils.equals("011702", mineid)) {
                saveLJTPowerData(newRuleRequestModelList);
            }
            //范各庄
            if (StringUtils.equals("011701", mineid)) {
                saveFGZPowerData(newRuleRequestModelList);
            }
            //唐山矿
            if (StringUtils.equals("010101", mineid)) {
                saveTsPowerData(newRuleRequestModelList);
            }
            //东欢坨
            if (StringUtils.equals("010102", mineid)) {
                saveDHTPowerData(newRuleRequestModelList);
            }
            //中润
            if (StringUtils.equals("011706", mineid)) {
                saveZRPowerData(newRuleRequestModelList);
            }
            //中浩
            if (StringUtils.equals("011708", mineid)) {
                saveZHPowerData(newRuleRequestModelList);
            }
            //钱家营
            if (StringUtils.equals("010105", mineid)) {
                saveQJYPowerData(newRuleRequestModelList);
            }
            //单侯
            if (StringUtils.equals("011204", mineid)) {
                saveDHPowerData(newRuleRequestModelList);
            }
            //宏丰
            if (StringUtils.equals("011502", mineid)) {
                savaHFPowerData(newRuleRequestModelList);
            }
        } else {
            return AjaxResult.error();
        }
        return AjaxResult.success();
    }

    /**
     * 宏丰
     *
     * @param newRuleRequestModelList
     */
    private void savaHFPowerData(List<NewRuleRequestModel> newRuleRequestModelList) {
        String month = newRuleRequestModelList.get(0).getWageMonth();
        String minId = newRuleRequestModelList.get(0).getMineid();
        newRuleRequestModelList.forEach(v -> v.setColoumn(v.getColoumn().replaceAll("-", StringUtils.EMPTY)));
        ReplaceBlank(newRuleRequestModelList);
        List<PowerDisplayDto> displayDtoList = this.getPowerDisplayDtoList(newRuleRequestModelList);
        List<PowerSourceModel> powerSourceModelList = powerDisplayMapper.selectSource(minId);
        List<PowerDisplayDto> collect = displayDtoList.stream().filter(v -> powerSourceModelList.stream().anyMatch(source -> StringUtils.equals(v.getClassificationName(), source.getClassificationName()))).collect(Collectors.toList());
        List<PowerDisplayDto> totalCollect = displayDtoList.stream().filter(v -> powerSourceModelList.stream().noneMatch(powerSourceModel -> StringUtils.equals(v.getClassificationName(), powerSourceModel.getClassificationName()))).collect(Collectors.toList());
        Optional<PowerDisplayDto> first = totalCollect.stream().findFirst();
        BigDecimal unitPrice = first.map(powerDisplayDto -> new BigDecimal(powerDisplayDto.getElectricityTotal()).divide(new BigDecimal(powerDisplayDto.getPowerTotal()), 2, RoundingMode.HALF_UP)).orElse(null);
        collect.forEach(v -> {
            assert unitPrice != null;
            v.setElectricityTotal(String.valueOf(unitPrice.multiply(new BigDecimal(v.getPowerTotal()))));
        });
        getPowerSource(month, minId, collect);
    }

    /**
     * 单侯
     *
     * @param newRuleRequestModelList
     */
    private void saveDHPowerData(List<NewRuleRequestModel> newRuleRequestModelList) {
        String month = newRuleRequestModelList.get(0).getWageMonth();
        String minId = newRuleRequestModelList.get(0).getMineid();
        ReplaceBlank(newRuleRequestModelList);
        List<PowerDisplayDto> displayDtoList = this.getPowerDisplayDtoList(newRuleRequestModelList);
        List<PowerSourceModel> powerSourceModelList = powerDisplayMapper.selectSource(minId);
        List<PowerDisplayDto> collect = displayDtoList.stream().filter(v -> powerSourceModelList.stream().anyMatch(powerSourceModel -> StringUtils.equals(v.getClassificationName(), powerSourceModel.getClassificationName()))).collect(Collectors.toList());
        collect.forEach(v -> v.setElectricityTotal(getAddValue(v)));
        getPowerSource(month, minId, collect);
    }

    /**
     * 钱家营
     *
     * @param newRuleRequestModelList
     */
    private void saveQJYPowerData(List<NewRuleRequestModel> newRuleRequestModelList) {
        String month = newRuleRequestModelList.get(0).getWageMonth();
        String minId = newRuleRequestModelList.get(0).getMineid();
        ReplaceBlank(newRuleRequestModelList);
        List<PowerDisplayDto> displayDtoList = this.getPowerDisplayDtoList(newRuleRequestModelList);
        List<String> stringList = new ArrayList<>();
        List<FilterModel> filterModelList = powerDisplayMapper.selectExist(minId);
        filterModelList.forEach(v -> {
            stringList.add(v.getDept());
            if (StringUtils.isNotBlank(v.getSecondDept())) {
                stringList.add(v.getSecondDept());
            }
            if (StringUtils.contains(v.getSecondDept(), ",")) {
                stringList.addAll(Arrays.asList(v.getSecondDept().split(",")));
            }
            stringList.removeIf(value -> StringUtils.contains(value, ","));
        });
        List<PowerDisplayDto> disposeList = displayDtoList.stream().filter(v -> stringList.stream().anyMatch(value -> StringUtils.equals(v.getClassificationName(), value))).collect(Collectors.toList());
        String[] array = new String[]{"煤管科", "货车队", "后勤服务中心", "职工食堂", "车队", "工业电光", "办公大楼", "综合办", "宾馆"};
        List<PowerDisplayDto> collect = disposeList.stream().filter(v -> StringUtils.equalsAny(v.getClassificationName(), array)).collect(Collectors.toList());
        //数据操作
        disposeData(collect);
        disposeList.forEach(v -> v.setElectricityTotal(getAddValue(v)));
        getPowerSource(month, minId, disposeList);

    }


    /**
     * 中浩
     *
     * @param newRuleRequestModelList
     */
    private void saveZHPowerData(List<NewRuleRequestModel> newRuleRequestModelList) {
        String month = newRuleRequestModelList.get(0).getWageMonth();
        String minId = newRuleRequestModelList.get(0).getMineid();
        ReplaceBlank(newRuleRequestModelList);
        List<PowerDisplayDto> displayDtoList = this.getPowerDisplayDtoList(newRuleRequestModelList);
        List<PowerSourceModel> powerSourceModelList = powerDisplayMapper.selectSource("011708");
        List<PowerDisplayDto> calculateCollect = displayDtoList.stream().filter(v -> powerSourceModelList.stream().noneMatch(powerSourceModel -> StringUtils.equals(v.getClassificationName(), powerSourceModel.getClassificationName()))).collect(Collectors.toList());
        List<PowerDisplayDto> dataCollect = displayDtoList.stream().filter(v -> powerSourceModelList.stream().anyMatch(powerSourceModel -> StringUtils.equals(v.getClassificationName(), powerSourceModel.getClassificationName()))).collect(Collectors.toList());
        List<PowerDisplayDto> collect = calculateCollect.stream().filter(v -> StringUtils.containsAny(v.getClassificationName(), "供电", "转供电")).collect(Collectors.toList());
        collect.forEach(v -> v.setClassificationName(StringUtils.substringAfterLast(v.getClassificationName(), ".")));
        Optional<PowerDisplayDto> powerSupplyOptional = collect.stream().filter(v -> StringUtils.equals("供电", v.getClassificationName())).findFirst();
        BigDecimal powerSupply = powerSupplyOptional.map(powerDisplayDto -> new BigDecimal(powerDisplayDto.getElectricityTotal()).divide(new BigDecimal(powerDisplayDto.getPowerTotal()), 4, RoundingMode.HALF_UP)).orElse(null);
        Optional<PowerDisplayDto> transferPowerSupplyOptional = collect.stream().filter(v -> StringUtils.equals("外供电", v.getClassificationName())).findFirst();
        BigDecimal transferPowerSupply = transferPowerSupplyOptional.map(powerDisplayDto -> new BigDecimal(powerDisplayDto.getElectricityTotal()).divide(new BigDecimal(powerDisplayDto.getPowerTotal()), 4, RoundingMode.HALF_UP)).orElse(null);
        List<PowerDisplayDto> transferPowerCollect = dataCollect.stream().filter(v -> StringUtils.equals("外购电量", v.getClassificationName())).collect(Collectors.toList());
        List<PowerDisplayDto> powerSupplyCollect = dataCollect.stream().filter(v -> !StringUtils.equals("外购电量", v.getClassificationName())).collect(Collectors.toList());
        transferPowerCollect.forEach(v -> v.setElectricityTotal(String.valueOf(new BigDecimal(v.getPowerTotal()).multiply(transferPowerSupply))));
        powerSupplyCollect.forEach(v -> v.setElectricityTotal(String.valueOf(new BigDecimal(v.getPowerTotal()).multiply(powerSupply))));
        List<PowerDisplayDto> finalPowerDisplayDtoList = new ArrayList<>();
        finalPowerDisplayDtoList.addAll(transferPowerCollect);
        finalPowerDisplayDtoList.addAll(powerSupplyCollect);
        List<PowerDisplayDto> powerDisplayDtoList = groupData(finalPowerDisplayDtoList);
        getPowerSource(month, minId, powerDisplayDtoList);
    }

    /**
     * 中润
     *
     * @param newRuleRequestModelList
     */
    private void saveZRPowerData(List<NewRuleRequestModel> newRuleRequestModelList) {
        String month = newRuleRequestModelList.get(0).getWageMonth();
        String minId = newRuleRequestModelList.get(0).getMineid();
        ReplaceBlank(newRuleRequestModelList);
        List<PowerDisplayDto> displayDtoList = this.getPowerDisplayDtoList(newRuleRequestModelList);
        List<PowerDisplayDto> powerDisplayDtoList = groupData(displayDtoList);
        powerDisplayDtoList.forEach(v -> {
            v.setPowerTotal(String.valueOf(new BigDecimal(v.getPowerTotal())));
            v.setElectricityTotal(String.valueOf(new BigDecimal(v.getElectricityTotal())));
        });
        getPowerSource(month, minId, powerDisplayDtoList);
    }

    /**
     * 东欢坨
     */
    private void saveDHTPowerData(List<NewRuleRequestModel> newRuleRequestModelList) {
        String month = newRuleRequestModelList.get(0).getWageMonth();
        String minId = newRuleRequestModelList.get(0).getMineid();
        ReplaceBlank(newRuleRequestModelList);
        List<PowerDisplayDto> displayDtoList = this.getPowerDisplayDtoList(newRuleRequestModelList);
        List<PowerSourceModel> powerSourceModelList = powerDisplayMapper.selectSource(minId);
        List<PowerDisplayDto> collect = displayDtoList.stream().filter(v -> powerSourceModelList.stream().anyMatch(source -> {
            if (!StringUtils.contains(v.getClassificationName(), "开滦")) {
                return StringUtils.contains(v.getClassificationName().replaceAll(".*）", StringUtils.EMPTY), source.getClassificationName());
            }
            return StringUtils.contains(v.getClassificationName(), source.getClassificationName());
        })).collect(Collectors.toList());
        collect.forEach(v -> {
            if (!StringUtils.contains(v.getClassificationName(), "开滦")) {
                v.setClassificationName(v.getClassificationName().replaceAll(".*\\)", StringUtils.EMPTY).replaceAll(".*）", StringUtils.EMPTY).replaceAll("\\u3000", StringUtils.EMPTY));
            } else {
                v.setClassificationName(StringUtils.substringAfterLast(v.getClassificationName(), "."));
            }
            v.setPowerTotal(new BigDecimal(v.getPowerTotal()).toPlainString());
            v.setElectricityTotal(new BigDecimal(v.getElectricityTotal().toLowerCase()).toPlainString());
        });
        List<PowerDisplayDto> powerDisplayDtoList = groupData(collect);
        getPowerSource(month, minId, powerDisplayDtoList);
    }


    /**
     * 唐山矿
     *
     * @param newRuleRequestModelList
     */
    private void saveTsPowerData(List<NewRuleRequestModel> newRuleRequestModelList) {
        String month = newRuleRequestModelList.get(0).getWageMonth();
        String minId = newRuleRequestModelList.get(0).getMineid();
        ReplaceBlank(newRuleRequestModelList);
        List<PowerDisplayDto> displayDtoList = this.getPowerDisplayDtoList(newRuleRequestModelList);
        List<PowerDisplayDto> powerDisplayDtoList = groupData(displayDtoList);
        getPowerSource(month, minId, powerDisplayDtoList);
    }


    /**
     * 范各庄
     *
     * @param powerDisplayDtoList
     */
    private void saveFGZPowerData(List<NewRuleRequestModel> powerDisplayDtoList) {
        ReplaceBlank(powerDisplayDtoList);
        List<PowerConvertSourceModel> sourceModelList = powerDisplayMapper.selectConvertSource("011701");
        List<NewRuleRequestModel> sourceDataList = powerDisplayDtoList.stream().filter(v -> sourceModelList.stream().anyMatch(source -> StringUtils.equals(v.getRow(), source.getNeedConvertSource()))).collect(Collectors.toList());
        List<NewRuleRequestModel> dataList = powerDisplayDtoList.stream().filter(v -> sourceModelList.stream().noneMatch(source -> StringUtils.equals(v.getRow(), source.getNeedConvertSource()))).collect(Collectors.toList());
        List<PowerDisplayDto> displayDtoList = getPowerDisplayDtoList(dataList);
        //计算部门电费
        calculateEleFeeByDept(sourceDataList, displayDtoList, sourceModelList);
    }

    /**
     * 吕家坨
     *
     * @param powerDisplayDtoList
     */
    private void saveLJTPowerData(List<NewRuleRequestModel> powerDisplayDtoList) {
        String month = powerDisplayDtoList.get(0).getWageMonth();
        String minId = powerDisplayDtoList.get(0).getMineid();
        ReplaceBlank(powerDisplayDtoList);
        List<PowerDisplayDto> displayDtoList = getPowerDisplayDtoList(powerDisplayDtoList);
        disposeParamter(displayDtoList);
        List<PowerDisplayDto> finalList = groupData(displayDtoList);
        List<PowerDisplayDto> collect = finalList.stream().filter(v -> !StringUtils.contains(v.getClassificationName(), "合计")).collect(Collectors.toList());
        List<PowerSourceModel> powerSourceModelList = powerDisplayMapper.selectSource("011702");
        collect = collect.stream().filter(v -> powerSourceModelList.stream().noneMatch(powerSourceModel -> StringUtils.equals(v.getClassificationName(), powerSourceModel.getLevelOneClassification()))).collect(Collectors.toList());
        collect.forEach(v -> {
            for (PowerSourceModel powerSourceModel : powerSourceModelList) {
                if (StringUtils.equals(v.getClassificationName(), powerSourceModel.getClassificationName())) {
                    v.setLevelOneClassification(powerSourceModel.getLevelOneClassification());
                }
            }
            v.setPowerTotal(new BigDecimal(v.getPowerTotal()).toPlainString());
            v.setElectricityTotal(new BigDecimal(v.getElectricityTotal()).toPlainString());
        });
        powerDisplayMapper.deleteRepeat(month, minId);
        powerDisplayMapper.insert(collect);
    }

    private void disposeData(List<PowerDisplayDto> collect) {
        //煤管科
        List<PowerDisplayDto> coalAdminCollect = collect.stream().filter(v -> StringUtils.equalsAny(v.getClassificationName(), "煤管科", "货车队")).collect(Collectors.toList());
        collect.forEach(v -> {
            if (StringUtils.equals("煤管科", v.getClassificationName())) {
                v.setMotivation(getSubtrctValue(coalAdminCollect, "0"));
                v.setLighting(getSubtrctValue(coalAdminCollect, "1"));
            }
        });
        //后勤服务中心
        List<PowerDisplayDto> logisticsList = collect.stream().filter(v -> StringUtils.equalsAny(v.getClassificationName(), "后勤服务中心", "职工食堂", "车队")).collect(Collectors.toList());
        collect.forEach(v -> {
            if (StringUtils.equals("后勤服务中心", v.getClassificationName())) {
                v.setMotivation(getSubtrctValue(logisticsList, "0"));
                v.setLighting(getSubtrctValue(logisticsList, "1"));
            }
        });
        //工业电光
        List<PowerDisplayDto> industryCollect = collect.stream().filter(v -> StringUtils.equalsAny(v.getClassificationName(), "工业电光", "办公大楼")).collect(Collectors.toList());
        collect.forEach(v -> {
            if (StringUtils.equals("工业电光", v.getClassificationName())) {
                v.setMotivation(getSubtrctValue(industryCollect, "0"));
                v.setLighting(getSubtrctValue(industryCollect, "1"));
            }
        });
        //综合办
        List<PowerDisplayDto> compositeCollect = collect.stream().filter(v -> StringUtils.equalsAny(v.getClassificationName(), "综合办", "宾馆")).collect(Collectors.toList());
        collect.forEach(v -> {
            if (StringUtils.equals("综合办", v.getClassificationName())) {
                v.setMotivation(getSubtrctValue(compositeCollect, "0"));
                v.setLighting(getSubtrctValue(compositeCollect, "1"));
            }
        });
    }

    private String getSubtrctValue(List<PowerDisplayDto> coalAdminCollect, String str) {
        BigDecimal difference = null;
        if (StringUtils.equals("0", str)) {
            List<BigDecimal> collect = coalAdminCollect.stream().map(v -> StringUtils.isBlank(v.getMotivation()) ? new BigDecimal(0) : new BigDecimal(v.getMotivation())).sorted(Comparator.reverseOrder()).collect(Collectors.toList());
            difference = getBigDecimalValue(collect);
        }
        if (StringUtils.equals("1", str)) {
            List<BigDecimal> collect = coalAdminCollect.stream().map(v -> StringUtils.isBlank(v.getLighting()) ? new BigDecimal(0) : new BigDecimal(v.getLighting())).sorted(Comparator.reverseOrder()).collect(Collectors.toList());
            difference = getBigDecimalValue(collect);
        }
        assert difference != null;
        return String.valueOf(difference.abs());
    }

    private BigDecimal getBigDecimalValue(List<BigDecimal> collect) {
        BigDecimal difference;
        BigDecimal maxValue = collect.stream().reduce(BigDecimal.ZERO, BigDecimal::max);
        List<BigDecimal> otherDataCollect = collect.stream().skip(1).collect(Collectors.toList());
        if (CollectionUtils.isEmpty(otherDataCollect)) {
            difference = maxValue.subtract(new BigDecimal(0));
        } else {
            difference = maxValue.subtract(otherDataCollect.stream().reduce(BigDecimal.ZERO, BigDecimal::add));
        }
        return difference;
    }


    private String getAddValue(PowerDisplayDto powerDisplayDto) {
        BigDecimal motivation = StringUtils.isBlank(powerDisplayDto.getMotivation()) ? new BigDecimal(0) : new BigDecimal(powerDisplayDto.getMotivation());
        BigDecimal lighting = StringUtils.isBlank(powerDisplayDto.getLighting()) ? new BigDecimal(0) : new BigDecimal(powerDisplayDto.getLighting());
        BigDecimal powerTip = StringUtils.isBlank(powerDisplayDto.getPowerTip()) ? new BigDecimal(0) : new BigDecimal(powerDisplayDto.getPowerTip());
        BigDecimal powerPeak = StringUtils.isBlank(powerDisplayDto.getPowerPeak()) ? new BigDecimal(0) : new BigDecimal(powerDisplayDto.getPowerPeak());
        BigDecimal powerFlat = StringUtils.isBlank(powerDisplayDto.getPowerFlat()) ? new BigDecimal(0) : new BigDecimal(powerDisplayDto.getPowerFlat());
        BigDecimal powerValley = StringUtils.isBlank(powerDisplayDto.getPowerValley()) ? new BigDecimal(0) : new BigDecimal(powerDisplayDto.getPowerValley());
        return String.valueOf(Stream.of(motivation, lighting, powerTip, powerPeak, powerFlat, powerValley).reduce(BigDecimal.ZERO, BigDecimal::add));
    }


    private void getPowerSource(String month, String minId, List<PowerDisplayDto> powerDisplayDtoList) {
        List<PowerSourceModel> powerSourceModelList = powerDisplayMapper.selectSource(minId);
        powerDisplayDtoList.forEach(v -> powerSourceModelList.forEach(source -> {
            if (StringUtils.equals(source.getClassificationName(), v.getClassificationName())) {
                v.setLevelOneClassification(source.getLevelOneClassification());
            }
        }));
        powerDisplayMapper.deleteRepeat(month, minId);
        powerDisplayMapper.insert(powerDisplayDtoList);
    }

    private List<PowerDisplayDto> groupData(List<PowerDisplayDto> displayDtoList) {
        Map<String, List<PowerDisplayDto>> collect = displayDtoList.stream().collect(Collectors.groupingBy(PowerDisplayDto::getClassificationName));
        List<PowerDisplayDto> finalList = new ArrayList<>();
        collect.forEach((k, v) -> {
            PowerDisplayDto pd = mergeData(v);
            finalList.add(pd);
        });
        return finalList;
    }

    private void calculateEleFeeByDept(List<NewRuleRequestModel> sourceDataList, List<PowerDisplayDto> displayDtoList, List<PowerConvertSourceModel> sourceModelList) {
        String month = sourceDataList.get(0).getWageMonth();
        String mindId = sourceDataList.get(0).getMineid();
        sourceDataList.forEach(v -> sourceModelList.forEach(s -> {
            if (StringUtils.equals(v.getRow(), s.getNeedConvertSource())) {
                v.setRow(s.getConvertSourceName());
            }
        }));
        Map<String, List<NewRuleRequestModel>> map = sourceDataList.stream().collect(Collectors.groupingBy(NewRuleRequestModel::getRow));
        List<SourceIndfoModel> sourceIndfoModelList = new ArrayList<>();
        map.forEach((k, v) -> v.forEach(a -> {
            SourceIndfoModel sourceIndfoModel = new SourceIndfoModel();
            if (v.size() > 2) {
                if (StringUtils.equals("电费总额", a.getColoumn())) {
                    sourceIndfoModel.setValueName(a.getValue());
                    sourceIndfoModel.setKeyName(a.getColoumn());
                    sourceIndfoModel.setSourceName(k);
                    sourceIndfoModelList.add(sourceIndfoModel);
                }
                if (StringUtils.equals("电量总额", a.getColoumn())) {
                    sourceIndfoModel.setValueName(a.getValue());
                    sourceIndfoModel.setKeyName(a.getColoumn());
                    sourceIndfoModel.setSourceName(k);
                    sourceIndfoModelList.add(sourceIndfoModel);
                }
            } else {
                sourceIndfoModel.setValueName(a.getValue());
                sourceIndfoModel.setKeyName(a.getColoumn());
                sourceIndfoModel.setSourceName(k);
                sourceIndfoModelList.add(sourceIndfoModel);
            }
        }));
        Map<String, List<SourceIndfoModel>> stringListMap = sourceIndfoModelList.stream().collect(Collectors.groupingBy(SourceIndfoModel::getSourceName));
        List<SourceIndfoModel> sourceInfoModels = new ArrayList<>();
        stringListMap.forEach((k, v) -> {
            SourceIndfoModel sourceIndfoModel = new SourceIndfoModel();
            List<BigDecimal> capacityList = v.stream().filter(a -> StringUtils.equals("电量总额", a.getKeyName())).map(a -> new BigDecimal(a.getValueName())).collect(Collectors.toList());
            List<BigDecimal> feeList = v.stream().filter(a -> StringUtils.equals("电费总额", a.getKeyName())).map(a -> new BigDecimal(a.getValueName())).collect(Collectors.toList());
            BigDecimal capacityReduce = capacityList.stream().reduce(BigDecimal.ZERO, BigDecimal::add);
            BigDecimal feeReduce = feeList.stream().reduce(BigDecimal.ZERO, BigDecimal::add);
            sourceIndfoModel.setSourceName(k);
            sourceIndfoModel.setUnitPrice(feeReduce.divide(capacityReduce, 2, RoundingMode.HALF_UP));
            sourceInfoModels.add(sourceIndfoModel);
        });
        List<PowerSourceModel> powerSourceModelList = powerDisplayMapper.selectSource("011701");
        displayDtoList.forEach(v -> powerSourceModelList.forEach(s -> {
            if (StringUtils.equals(v.getClassificationName(), s.getClassificationName())) {
                v.setLevelOneClassification(s.getLevelOneClassification());
            }
        }));
        displayDtoList.forEach(v -> sourceInfoModels.forEach(s -> {
            if (StringUtils.equals(v.getLevelOneClassification(), s.getSourceName())) {
                v.setElectricityTotal(String.valueOf(new BigDecimal(v.getPowerTotal()).multiply(s.getUnitPrice()).setScale(2, RoundingMode.HALF_UP)));
            }
        }));
        powerDisplayMapper.deleteRepeat(month, mindId);
        powerDisplayMapper.insert(displayDtoList);
    }

    private PowerDisplayDto mergeData(List<PowerDisplayDto> powerDisplayDtoList) {
        return powerDisplayDtoList.stream().collect(Collectors.collectingAndThen(Collectors.toMap(data -> data.getMindId() + data.getClassificationName() + data.getDateColumn(), data -> data, (existingData, newData) -> {
            existingData.setPowerTotal(StringUtils.isEmpty(existingData.getPowerTotal()) ? newData.getPowerTotal() : existingData.getPowerTotal());
            existingData.setPowerTip(StringUtils.isEmpty(existingData.getPowerTip()) ? newData.getPowerTip() : existingData.getPowerTip());
            existingData.setPowerPeak(StringUtils.isEmpty(existingData.getPowerPeak()) ? newData.getPowerPeak() : existingData.getPowerPeak());
            existingData.setPowerFlat(StringUtils.isEmpty(existingData.getPowerFlat()) ? newData.getPowerFlat() : existingData.getPowerFlat());
            existingData.setPowerValley(StringUtils.isEmpty(existingData.getPowerValley()) ? newData.getPowerValley() : existingData.getPowerValley());
            existingData.setElectricityTotal(StringUtils.isEmpty(existingData.getElectricityTotal()) ? newData.getElectricityTotal() : existingData.getElectricityTotal());
            existingData.setElectricityTip(StringUtils.isEmpty(existingData.getElectricityTip()) ? newData.getElectricityTip() : existingData.getElectricityTip());
            existingData.setElectricityPeak(StringUtils.isEmpty(existingData.getElectricityPeak()) ? newData.getElectricityPeak() : existingData.getElectricityPeak());
            existingData.setElectricityFlat(StringUtils.isEmpty(existingData.getElectricityFlat()) ? newData.getElectricityFlat() : existingData.getElectricityFlat());
            existingData.setElectricityValley(StringUtils.isEmpty(existingData.getElectricityValley()) ? newData.getElectricityValley() : existingData.getElectricityValley());
            existingData.setElectricityPriceTip(StringUtils.isEmpty(existingData.getElectricityPriceTip()) ? newData.getElectricityPriceTip() : existingData.getElectricityPriceTip());
            existingData.setElectricityPricePeak(StringUtils.isEmpty(existingData.getElectricityPricePeak()) ? newData.getElectricityPricePeak() : existingData.getElectricityPricePeak());
            existingData.setElectricityPriceFlat(StringUtils.isEmpty(existingData.getElectricityPriceFlat()) ? newData.getElectricityPriceFlat() : existingData.getElectricityPriceFlat());
            existingData.setElectricityPriceValley(StringUtils.isEmpty(existingData.getElectricityPriceValley()) ? newData.getElectricityPriceValley() : existingData.getElectricityPriceValley());
            existingData.setLevelOneClassification(StringUtils.isEmpty(existingData.getLevelOneClassification()) ? newData.getLevelOneClassification() : existingData.getLevelOneClassification());
            existingData.setLevelTwoClassification(StringUtils.isEmpty(existingData.getLevelTwoClassification()) ? newData.getLevelTwoClassification() : existingData.getLevelTwoClassification());
            existingData.setLevelThreeClassification(StringUtils.isEmpty(existingData.getLevelThreeClassification()) ? newData.getLevelThreeClassification() : existingData.getLevelThreeClassification());
            existingData.setBasicElectricityTariff(StringUtils.isEmpty(existingData.getBasicElectricityTariff()) ? newData.getBasicElectricityTariff() : existingData.getBasicElectricityTariff());
            existingData.setLighting(StringUtils.isEmpty(existingData.getLighting()) ? newData.getLighting() : existingData.getLighting());
            existingData.setMotivation(StringUtils.isEmpty(existingData.getMotivation()) ? newData.getMotivation() : existingData.getMotivation());
            return existingData;
        }), map -> map.values().iterator().next()));
    }


    private List<PowerDisplayDto> getPowerDisplayDtoList(List<NewRuleRequestModel> powerDisplayDtoList) {
        List<PowerDisplayDto> displayDtoList = new ArrayList<>();
        List<ConfigModel> configModelList = powerDisplayMapper.seletPowerConfig();
        Map<String, List<NewRuleRequestModel>> map = powerDisplayDtoList.stream().collect(Collectors.groupingBy(NewRuleRequestModel::getRow));
        map.forEach((k, v) -> {
            PowerDisplayDto powerDisplayDto = new PowerDisplayDto();
            for (NewRuleRequestModel newRuleRequestModel : v) {
                for (ConfigModel configModel : configModelList) {
                    if (StringUtils.contains(configModel.getColName(), newRuleRequestModel.getColoumn())) {
                        Field field;
                        try {
                            field = PowerDisplayDto.class.getDeclaredField(configModel.getKeyName());
                            ReflectionUtils.makeAccessible(field);
                            ReflectionUtils.setField(field, powerDisplayDto, newRuleRequestModel.getValue());
                        } catch (NoSuchFieldException e) {
                            throw new RuntimeException(e);
                        }
                    }
                }
                powerDisplayDto.setClassificationName(k);
                powerDisplayDto.setDateColumn(newRuleRequestModel.getWageMonth());
                powerDisplayDto.setMindId(newRuleRequestModel.getMineid());
            }
            displayDtoList.add(powerDisplayDto);
        });
        return displayDtoList;

    }


    private void ReplaceBlank(List<NewRuleRequestModel> powerDisplayDtoList) {
        powerDisplayDtoList.forEach(v -> {
            v.setRow(v.getRow().replaceAll(StringUtils.SPACE, StringUtils.EMPTY));
            v.setValue(v.getValue().replaceAll(StringUtils.SPACE, StringUtils.EMPTY));
            v.setColoumn(v.getColoumn().replaceAll(StringUtils.SPACE, StringUtils.EMPTY));
            if (StringUtils.equalsAny(v.getMineid(), "011702", "011701")) {
                v.setColoumn(v.getColoumn().replaceAll("\\(.*?\\)", StringUtils.EMPTY));
                v.setColoumn(v.getColoumn().replaceAll("（.*?）", StringUtils.EMPTY));
            }
        });
    }

    private void disposeParamter(List<PowerDisplayDto> displayDtoList) {
        for (PowerDisplayDto powerDisplayDto : displayDtoList) {
            if (StringUtils.contains(powerDisplayDto.getClassificationName(), "其中")) {
                powerDisplayDto.setClassificationName(powerDisplayDto.getClassificationName().replaceAll("其中：", StringUtils.EMPTY));
            }
            powerDisplayDto.setClassificationName(powerDisplayDto.getClassificationName().replaceAll("[^\\u4e00-\\u9fa5]", StringUtils.EMPTY));
        }
    }
}
